/*
 * JDBCLoginModule.java
 *
 * Created on September 5, 2007, 10:59 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.sun.test.realm;

import com.sun.appserv.security.AppservPasswordLoginModule;
import com.sun.enterprise.security.LoginException;
import java.sql.SQLException;

/**
 *
 * @author hr124446
 */
public class JDBCLoginModule extends AppservPasswordLoginModule {

   public JDBCLoginModule () {

      super();
   }

   protected void authenticateUser ()
      throws LoginException {

      String[] groupList;

      if (!(_currentRealm instanceof JDBCRealm)) {
         throw new LoginException("Module only functions with linked realm implementation");
      }

      try {
         if ((groupList = ((JDBCRealm)_currentRealm).authenticateUser(_username,
_password)) == null) {
            throw new LoginException(_username);
         }
      }
      catch (SQLException sqlException) {

         LoginException loginException;

         loginException = new LoginException(sqlException.getMessage());
         loginException.initCause(sqlException);

         throw loginException;
      }

      commitUserAuthentication(groupList);
   }
}



